*************************
* CHISQR.PRG
* Copyright Clifford Green,  March 1, 1990
*
* This file uses two formulae to calculate the Chi Square statistic.  You
* obviously should use whichever is more to your liking or lends itself to
* your analytic bent.  They should yield the same figure, or be remarkably
* close.  Be advised that as of the current version of this material, the
* program does not generate a p level for your results;  you must look this
* up yourself - any good stat book will have the appropriate tables.
*************************
CLEAR
FILNAME = SPACE(8)
DIR
@ ROW()+2,5 SAY [Which file?] GET FILNAME PICT [@!]
READ
USE (FILNAME)
N = RECCOUNT()
*************************
NUM_FIELDS = FCOUNT()
* CHOICES[] AND i ARE USED BY THE UDF FOR ACHOICE()
PUBLIC CHOICES[NUM_FIELDS], FIELDS[NUM_FIELDS], i
i = 0
* FILL THE FIELDS[] ARRAY WITH (FILNAME) FIELDNAMES
AFIELDS(FIELDS)
CLEAR
@ 24, 0 SAY [Press Enter to select fields for analysis and Esc to list.]
USERCHOICE = ACHOICE(1,10,23,35,FIELDS, .T., "SAVE_IT")
*************************
CLEAR
DECLARE CRIT[4],HEAD[4]
AFILL(CRIT,SPACE(80))
AFILL(HEAD,SPACE(10))
* This version does the Chi Square analysis in the context of exposure
* and disease outcomes.  This is easy to revise per your analytic context.
@  2, 5 SAY [Using variable ]+choices[1]+[ and ]+choices[2]
@  5, 5 SAY [Enter the criteria for the exposed column]
@  6, 5 GET CRIT[1] PICT [@!S50]
@  7,10 SAY [Enter exposed column header for chart: ] GET HEAD[1] PICT [@!]
@  8, 5 SAY [Enter the criteria for the unexposed column]
@  9, 5 GET CRIT[2] PICT [@!S50]
@ 10,10 SAY [Enter unexposed column header for chart: ] GET HEAD[2] PICT [@!]
@ 11, 5 SAY [Enter the criteria for the diseased row]
@ 12, 5 GET CRIT[3] PICT [@!S50]
@ 13,10 SAY [Enter diseased row header for chart: ] GET HEAD[3] PICT [@!]
@ 14, 5 SAY [Enter the criteria for the undiseased row]
@ 15, 5 GET CRIT[4] PICT [@!S50]
@ 16,10 SAY [Enter undiseased row header for chart: ] GET HEAD[4] PICT [@!]
READ
CRIT1 = LTRIM(RTRIM(CRIT[1]))
CRIT2 = LTRIM(RTRIM(CRIT[2]))
CRIT3 = LTRIM(RTRIM(CRIT[3]))
CRIT4 = LTRIM(RTRIM(CRIT[4]))
@ 18, 5 SAY [Counting cell A (exposed and diseased)]
COUNT FOR &CRIT1 .AND. &CRIT3 TO A
@ 19, 5 SAY [Counting cell B (unexposed and diseased)]
COUNT FOR &CRIT2 .AND. &CRIT3 TO B
@ 20, 5 SAY [Counting cell C (exposed and undiseased)]
COUNT FOR &CRIT1 .AND. &CRIT4 TO C
@ 21, 5 SAY [Counting cell D (unexposed and undiseased)]
COUNT FOR &CRIT2 .AND. &CRIT4 TO D
@ 22, 5 SAY [Calculating Chi Square statistic]
ADBC = A*D - B*C
ADBC = IF(ADBC < 0,-1*ADBC,ADBC)
CHISQR = (N* (ADBC - .05 * N) ^2) / ((A+B) * (C+D) * (A+C) * (B+D))
SET PRINT ON
? [For the file of ]+ FILNAME
?
? SPACE(24-(LEN(HEAD[1])/2))+HEAD[1]+SPACE(9-(LEN(HEAD[1])/2))+CHR(179)+SPACE(10-(LEN(HEAD[2])/2))+HEAD[2]
? SPACE(13)+CHR(218)+REPLICATE(CHR(196),19)+CHR(197)+REPLICATE(CHR(196),19)+CHR(191)
? HEAD[3]+SPACE(13-LEN(HEAD[3]))+CHR(179)+SPACE(10-(LEN(LTRIM(STR(A)))))+LTRIM(STR(A))+SPACE(9)+CHR(179)+SPACE(10-(LEN(LTRIM(STR(B)))))+LTRIM(STR(B))+SPACE(9)+CHR(179)
? REPLICATE(CHR(196),13)+CHR(197)+REPLICATE(CHR(196),19)+CHR(197)+REPLICATE(CHR(196),19)+CHR(180)
? HEAD[4]+SPACE(13-LEN(HEAD[4]))+CHR(179)+SPACE(10-(LEN(LTRIM(STR(C)))))+LTRIM(STR(C))+SPACE(9)+CHR(179)+SPACE(10-(LEN(LTRIM(STR(D)))))+LTRIM(STR(D))+SPACE(9)+CHR(179)
? SPACE(13)+CHR(192)+REPLICATE(CHR(196),19)+CHR(193)+REPLICATE(CHR(196),19)+CHR(217)
?
? [Where:]
? HEAD[1]+[ is defined as ]+CRIT1
? HEAD[2]+[ is defined as ]+CRIT2
? HEAD[3]+[ is defined as ]+CRIT3
? HEAD[4]+[ is defined as ]+CRIT4
?
? [Using the formula n*(|ad-bc| -0.5*n)^2]
? [                  --------------------]
? [                  (a+b)(c+d)(a+c)(b+d)]
?
?
? [OBSERVED FOR A =    ] + STR(A)
? [OBSERVED FOR B =    ] + STR(B)
? [OBSERVED FOR C =    ] + STR(C)
? [OBSERVED FOR D =    ] + STR(D)
? [                       ----------]
? [OBSERVED        N =    ] + STR(N)
**    you pull the p level from a Chi Square table yourself and insert it
? [Chi Square stat = ] + STR(CHISQR) + [, p < ]
?
SET PRINT OFF
RELEASE CHISQR    && just in case
? [Calculating Chi Square statistic]
EXPECTEDA = ((A+C) * (A+B))/N
CHISQR = (A - EXPECTEDA)^2 / EXPECTEDA
EXPECTEDB = ((B+D) * (A+B))/N
CHISQR = (B - EXPECTEDB)^2 / EXPECTEDB
EXPECTEDC = ((A+C) * (C+D))/N
CHISQR = (C - EXPECTEDC)^2 / EXPECTEDC
EXPECTEDD = ((B+D) * (C+D))/N
CHISQR = (D - EXPECTEDD)^2 / EXPECTEDD
SET PRINT ON
?
? [Using the formula   --   (observed-expected)^2]
? [                    >    ---------------------]
? [                    --         expected]
?
?
? [OBSERVED FOR A =   ] + STR(A)
? [EXPECTED FOR A =   ] + STR(EXPECTEDA)
? [OBSERVED FOR B =   ] + STR(B)
? [EXPECTED FOR B =   ] + STR(EXPECTEDB)
? [OBSERVED FOR C =   ] + STR(C)
? [EXPECTED FOR C =   ] + STR(EXPECTEDC)
? [OBSERVED FOR D =   ] + STR(D)
? [EXPECTED FOR D =   ] + STR(EXPECTEDD)
? [                      ----------]
? [OBSERVED        N =   ] + STR(N)
? [Chi Squared stat = ] + STR(CHISQR) + [, p <]
?
** The following material on relative risk concerns the ratio of incidence
** of some outcome (e.g., death or disease) from two different groups and
** the relative probability of members of those groups to succumb to whatever
** the outcome is.
RR = (A/(A+B))/(C/(C+D))
?
? [Using the formula RR = (A/(A+B))/(C/(C+D)), the relative risk is:  ]+LTRIM(STR(RR))
** The following checks to see if the Chi Square is actually appropriate for
** the sample size taken
IF A < 5 .OR. EXPECTEDD < 5
   ?
   ? [   ** Since one or more of the 2x2 cells is less than 5,]
   ? [      the Chi Square statistic is not appropriate]
ENDIF
EJECT
SET PRINT OFF
*************************
FUNCTION SAVE_IT
PARAMETERS MODE, ELEMENT, ROW_NUM
KEY = LASTKEY()
DO CASE
   * IF USER PRESSES ENTER, FIELD NAME IS MARKED AND SAVED
   CASE KEY = 13
      i = i + 1
      CHOICES[i] = FIELDS[ELEMENT]
      @ ROW_NUM + 1, 9 SAY CHR(175)
      RETURN 2
   CASE KEY = 27
      RETURN 0
   OTHERWISE
      RETURN 2
ENDCASE   
