*************************
* TTEST.PRG
* Copyright Clifford Green,  March 1, 1990
*
* This file calculates Student's t statistic for the difference between
* a sample mean and the population mean;  you will need to give the
* program a value for the population mean, and the program assumes that
* the dataset used represents your sample.  You could, conceivably, rewrite
* this snippet to allow selection of a subset as your sample, preferably
* with a random number generator to ease the constraints on sampling.
*************************
CLEAR
FILNAME = SPACE(8)
DIR
@ ROW()+2,5 SAY [Which file?] GET FILNAME PICT [@!]
READ
USE (FILNAME)
N = RECCOUNT()
*************************
NUM_FIELDS = FCOUNT()
PUBLIC FIELDS[NUM_FIELDS]
* FILL THE FIELDS[] ARRAY WITH (FILNAME) FIELDNAMES
AFIELDS(FIELDS)
CLEAR
@ 24, 0 SAY [Press Enter to select field for analysis.]
TESTVAR = FIELDS[ACHOICE(1,10,23,35,FIELDS)]
*************************
CLEAR
STORE 0 TO Mu, SUMSQUARES, SQUAREDSUM, CORECTERM, df
@  2, 5 SAY [Using variable ]+TESTVAR
@  5, 5 SAY [Enter the Population Mean (mu): ] GET Mu
DO WHILE .T.
   READ
   IF Mu > 0
      EXIT
   ENDIF
   ?? CHR(7)+CHR(7)
   @ 9,5 TO 11,67
   @ 10,15 SAY [***** BAD OR MISSING Mu.  TRY AGAIN!! *****]
   INKEY(2)
   @ 9,5 CLEAR TO 11,67
END
SUM SUM &TESTVAR TO SCORESUM
SAMPLEMEAN = SCORESUM / N
GO TOP
DO WHILE !EOF()
   SUMSQUARES = SUMSQUARES + &VARTEST.^2
ENDDO
SQUAREDSUM = SCORESUM^2
CORECTERM = SQUAREDSUM/N
df = N-1
t = (Mu - SAMPLEMEAN)/(SQRT(CORECTERM/df)/SQRT(N))

? [For the file of ]+ FILNAME + [ Student's t = ] + ltrim(str(t))
** you look up the significance level yourself, based on:
? [You can look up the alpha level using  df = ] + ltrim(str(df))
